# All files / coa/lib cmd.js

81.22% Statements 147/181
71.64% Branches 96/134
68.75% Functions 33/48
82.53% Lines 137/166

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200
    201
    202
    203
    204
    205
    206
    207
    208
    209
    210
    211
    212
    213
    214
    215
    216
    217
    218
    219
    220
    221
    222
    223
    224
    225
    226
    227
    228
    229
    230
    231
    232
    233
    234
    235
    236
    237
    238
    239
    240
    241
    242
    243
    244
    245
    246
    247
    248
    249
    250
    251
    252
    253
    254
    255
    256
    257
    258
    259
    260
    261
    262
    263
    264
    265
    266
    267
    268
    269
    270
    271
    272
    273
    274
    275
    276
    277
    278
    279
    280
    281
    282
    283
    284
    285
    286
    287
    288
    289
    290
    291
    292
    293
    294
    295
    296
    297
    298
    299
    300
    301
    302
    303
    304
    305
    306
    307
    308
    309
    310
    311
    312
    313
    314
    315
    316
    317
    318
    319
    320
    321
    322
    323
    324
    325
    326
    327
    328
    329
    330
    331
    332
    333
    334
    335
    336
    337
    338
    339
    340
    341
    342
    343
    344
    345
    346
    347
    348
    349
    350
    351
    352
    353
    354
    355
    356
    357
    358
    359
    360
    361
    362
    363
    364
    365
    366
    367
    368
    369
    370
    371
    372
    373
    374
    375
    376
    377
    378
    379
    380
    381
    382
    383
    384
    385
    386
    387
    388
    389
    390
    391
    392
    393
    394
    395
    396
    397
    398
    399
    400
    401
    402
    403
    404
    405
    406
    407
    408
    409
    410
    411
    412
    413
    414
    415
    416
    417
    418
    419
    420
    421
    422
    423
    424
    425
    426
    427
    428
    429
    430
    431
    432
    433
    434
    435
    436
    437
    438
    439
    440
    441
    442
    443
    444
    445
    446
    447
    448
    449
    450
    451
    452
    453
    454
    455
    456
    457
    458
    459
    460
    461
    462
    463
    464
    465
    466
    467
    468
    469
    470
    471
    472
    473
    474
    475
    476
    477
    478
    479
    480
    481
    482
    483
    484
    485
    486
    487
    488
    489
    490
    491
    492
    493
    494
    495
    496
    497
    498

    1x
    1x
    1x

    1x

    1x
    1x
    1x
    1x
    1x

    26x

    26x
    26x
    26x
    26x
    26x
    26x
    26x
    26x

    21x

    2x
    2x
    1x

    2x
    2x
    1x

    2x

    28x

    28x

    28x

    44x

    12x

    12x

    12x

    7x

    16x

    16x

    16x

    16x
    16x

    16x

    5x
    5x

    19x
    19x
    1x

    18x

    22x

    21x

    21x
    41x
    2x

    35x

    35x
    35x
    75x

    75x
    62x
    62x

    13x
    13x
    5x
    2x

    3x
    3x
    3x
    3x
    4x
    4x
    1x

    5x
    5x
    5x
    3x

    2x
    2x
    2x

    5x

    13x

    5x

    27x

    24x
    24x
    24x
    24x

    24x
    47x
    19x
    19x
    1x
    1x

    19x
    19x

    18x

    17x

    28x
    28x

    28x
    30x
    30x

    28x
    28x

    20x

    44x
    14x

    44x

    4x

    4x
    3x

    3x

    3x
    3x

    3x
    4x

    4x

    24x
    24x

    26x
    22x

    44x

    3x
    3x
    3x
    3x

    3x
    1x
    1x
    1x

    3x
    3x
    1x

    2x

    2x

    1x
    24x

    5x
    5x

    1x
     'use strict';

    const
        UTIL = require('util'),
        PATH = require('path'),
        EOL = require('os').EOL,

        Q = require('q'),

        CoaObject = require('./coaobject'),
        Color = require('./color'),
        Opt = require('./opt'),
        Arg = require('./arg'),
        completion = require('./completion');

    /**
     * Command
     *
     * Top level entity. Commands may have options and arguments.
     *
     * @namespace
     * @class Cmd
     * @extends CoaObject
     */
    class Cmd extends CoaObject {
        /**
         * @constructs
         * @param {COA.Cmd} [cmd] parent command
         */
        constructor(cmd) {
            super(cmd);

            this._parent(cmd);
            this._cmds = [];
            this._cmdsByName = {};
            this._opts = [];
            this._optsByKey = {};
            this._args = [];
            this._api = null;
            this._ext = false;
        }

        static create(cmd) {
            return new Cmd(cmd);
        }

        /**
         * Returns object containing all its subcommands as methods
         * to use from other programs.
         *
         * @returns {Object}
         */
        get api() {
            // Need _this here because of passed arguments into _api
            const _this = this;
            this._api || (this._api = function () {
                return _this.invoke.apply(_this, arguments);
            });

            const cmds = this._cmdsByName;
            Object.keys(cmds).forEach((c) => {
                this._api[c] = cmds[c].api;
            });
            return this._api;
        }

        _parent(cmd) {
            this._cmd = cmd || this;

            this.isRootCmd
                || cmd._cmds.push(this)
                && this._name
                && (this._cmd._cmdsByName[this._name] = this);

            return this;
        }

        get isRootCmd() {
            return this._cmd === this;
        }

        /**
         * Set a canonical command identifier to be used anywhere in the API.
         *
         * @param {String} name - command name
         * @returns {COA.Cmd} - this instance (for chainability)
         */
        name(name) {
            super.name(name);

            this.isRootCmd
                || (this._cmd._cmdsByName[name] = this);

            return this;
        }

        /**
         * Create new or add existing subcommand for current command.
         *
         * @param {COA.Cmd} [cmd] existing command instance
         * @returns {COA.Cmd} new subcommand instance
         */
        cmd(cmd) {
            return cmd?
                cmd._parent(this)
                : new Cmd(this);
        }

        /**
         * Create option for current command.
         *
         * @returns {COA.Opt} new option instance
         */
        opt() {
            return new Opt(this);
        }

        /**
         * Create argument for current command.
         *
         * @returns {COA.Opt} new argument instance
         */
        arg() {
            return new Arg(this);
        }

        /**
         * Add (or set) action for current command.
         *
         * @param {Function} act - action function,
         *         invoked in the context of command instance
         *         and has the parameters:
         *                 - {Object} opts - parsed options
         *                 - {String[]} args - parsed arguments
         *                 - {Object} res - actions result accumulator
         *         It can return rejected promise by Cmd.reject (in case of error)
         *         or any other value treated as result.
         * @param {Boolean} [force=false] flag for set action instead add to existings
         * @returns {COA.Cmd} - this instance (for chainability)
         */
        act(act, force) {
            Iif(!act) return this;

            (!this._act || force) && (this._act = []);
            this._act.push(act);

            return this;
        }

        /**
         * Make command "helpful", i.e. add -h --help flags for print usage.
         *
         * @returns {COA.Cmd} - this instance (for chainability)
         */
        helpful() {
            return this.opt()
                .name('help')
                .title('Help')
                .short('h')
                .long('help')
                .flag()
                .only()
                .act(function() {
                    return this.usage();
                })
                .end();
        }

        /**
         * Adds shell completion to command, adds "completion" subcommand,
         * that makes all the magic.
         * Must be called only on root command.
         *
         * @returns {COA.Cmd} - this instance (for chainability)
         */
        completable() {
            return this.cmd()
                .name('completion')
                .apply(completion)
                .end();
        }

        /**
         * Allow command to be extendable by external node.js modules.
         *
         * @param {String} [pattern]  Pattern of node.js module to find subcommands at.
         * @returns {COA.Cmd} - this instance (for chainability)
         */
        extendable(pattern) {
            this._ext = pattern || true;
            return this;
        }

        _exit(msg, code) {
            return process.once('exit', function() {
                msg && console.error(msg);
                return process.exit(code || 0);
            });
        }

        /**
         * Build full usage text for current command instance.
         *
         * @returns {String} usage text
         */
        usage() {
            const res = [];

            this._title && res.push(this._fullTitle());

            res.push('', 'Usage:');

            this._cmds.length
                && res.push([
                    '', '', Color('lred', this._fullName()), Color('lblue', 'COMMAND'),
                    Color('lgreen', '[OPTIONS]'), Color('lpurple', '[ARGS]')
                ].join(' '));

            (this._opts.length + this._args.length)
                && res.push([
                    '', '', Color('lred', this._fullName()),
                    Color('lgreen', '[OPTIONS]'), Color('lpurple', '[ARGS]')
                ].join(' '));

            res.push(
                this._usages(this._cmds, 'Commands'),
                this._usages(this._opts, 'Options'),
                this._usages(this._args, 'Arguments')
            );

            return res.join(EOL);
        }

        _usage() {
            return Color('lblue', this._name) + ' : ' + this._title;
        }

        _usages(os, title) {
            if(!os.length) return;

            return ['', title + ':']
                .concat(os.map(o => `  ${o._usage()}`))
                .join(EOL);
        }

        _fullTitle() {
            return `${this.isRootCmd? '' : this._cmd._fullTitle() + EOL}${this._title}`;
        }

        _fullName() {
            return `${this.isRootCmd? '' : this._cmd._fullName() + ' '}${PATH.basename(this._name)}`;
        }

        _ejectOpt(opts, opt) {
            const pos = opts.indexOf(opt);
            if(pos === -1)
                return;

            return opts[pos]._arr?
                opts[pos]
                : opts.splice(pos, 1)[0];
        }

        _checkRequired(opts, args) {
            if(this._opts.some(opt => opt._only && opt._name in opts)) return;

            const all = this._opts.concat(this._args);
            let i;
            while(i = all.shift())
                if(i._req && i._checkParsed(opts, args))
                    return this.reject(i._requiredText());
        }

        _parseCmd(argv, unparsed) {
            unparsed || (unparsed = []);

            let i,
                optSeen = false;
            while(i = argv.shift()) {
                i.indexOf('-') || (optSeen = true);

                if(optSeen || !/^\w[\w-_]*$/.test(i)) {
                    unparsed.push(i);
                    continue;
                }

                let pkg, cmd = this._cmdsByName[i];
                if(!cmd && this._ext) {
                    if(typeof this._ext === 'string') {
                        pkg = ~this._ext.indexOf('%s')?
                            UTIL.format(this._ext, i)
                            : this._ext + i;

                    } else Eif(this._ext === true) {
                        pkg = i;
                        let c = this;
                        while(true) { // eslint-disable-line
                            pkg = c._name + '-' + pkg;
                            if(c.isRootCmd) break;
                            c = c._cmd;
                        }
                    }

                    const cmdDesc = tryCatch(() => require(pkg));
                    Eif(cmdDesc) {
                        if(typeof cmdDesc === 'function') {
                            this.cmd().name(i).apply(cmdDesc).end();

                        } else Eif(typeof cmdDesc === 'object') {
                            this.cmd(cmdDesc);
                            cmdDesc.name(i);

                        } else throw new Error('Error: Unsupported command declaration type, '
                            + 'should be a function or COA.Cmd() object');

                        cmd = this._cmdsByName[i];
                    }
                }

                if(cmd) return cmd._parseCmd(argv, unparsed);

                unparsed.push(i);
            }

            return { cmd : this, argv : unparsed };
        }

        _parseOptsAndArgs(argv) {
            const opts = {},
                args = {},
                nonParsedOpts = this._opts.concat(),
                nonParsedArgs = this._args.concat();

            let res, i;
            while(i = argv.shift()) {
                if(i !== '--' && i[0] === '-') {
                    const m = i.match(/^(--\w[\w-_]*)=(.*)$/);
                    if(m) {
                        i = m[1];
                        this._optsByKey[i]._flag || argv.unshift(m[2]);
                    }

                    const opt = this._ejectOpt(nonParsedOpts, this._optsByKey[i]);
                    if(!opt) return this.reject(`Unknown option: ${i}`);

                    if(Q.isRejected(res = opt._parse(argv, opts))) return res;

                    continue;
                }

                i === '--' && (i = argv.splice(0));
                Array.isArray(i) || (i = [i]);

                let a;
                while(a = i.shift()) {
                    let arg = nonParsedArgs.shift();
                    if(!arg) return this.reject(`Unknown argument: ${a}`);

                    arg._arr && nonParsedArgs.unshift(arg);
                    Iif(Q.isRejected(res = arg._parse(a, args))) return res;
                }
            }

            return {
                opts : this._setDefaults(opts, nonParsedOpts),
                args : this._setDefaults(args, nonParsedArgs)
            };
        }

        _setDefaults(params, desc) {
            for(const item of desc)
                item._def
                    && !(item._name in params)
                    && item._saveVal(params, item._def);

            return params;
        }

        _processParams(params, desc) {
            const notExists = [];

            for(const item of desc) {
                const n = item._name;

                Iif(!(n in params)) {
                    notExists.push(item);
                    continue;
                }

                const vals = [].concat(params[n]);
                delete params[n];

                let res;
                for(const v of vals)
                    Iif(Q.isRejected(res = item._saveVal(params, v)))
                        return res;
            }

            return this._setDefaults(params, notExists);
        }

        _parseArr(argv) {
            return Q.when(this._parseCmd(argv), (p) =>
                Q.when(p.cmd._parseOptsAndArgs(p.argv), (r) => ({
                    cmd : p.cmd,
                    opts : r.opts,
                    args : r.args
                })));
        }

        _do(inputPromise) {
            return Q.when(inputPromise, (input) => {
                return [this._checkRequired]
                    .concat(input.cmd._act || [])
                    .reduce((res, act) =>
                        Q.when(res, (prev) => act.call(input.cmd, input.opts, input.args, prev)),
                        void 0);
            });
        }

        /**
         * Parse arguments from simple format like NodeJS process.argv
         * and run ahead current program, i.e. call process.exit when all actions done.
         *
         * @param {String[]} argv - arguments
         * @returns {COA.Cmd} - this instance (for chainability)
         */
        run(argv) {
            argv || (argv = process.argv.slice(2));

            const cb = (code) => (res) => res?
                this._exit(res.stack || res.toString(), res.exitCode || code)
                : this._exit();

            Q.when(this.do(argv), cb(0), cb(1)).done();

            return this;
        }

        /**
         * Invoke specified (or current) command using provided
         * options and arguments.
         *
         * @param {String|String[]} [cmds] - subcommand to invoke (optional)
         * @param {Object} [opts] - command options (optional)
         * @param {Object} [args] - command arguments (optional)
         * @returns {Q.Promise}
         */
        invoke(cmds, opts, args) {
            cmds || (cmds = []);
            opts || (opts = {});
            args || (args = {});
            typeof cmds === 'string' && (cmds = cmds.split(' '));

            if(arguments.length < 3 && !Array.isArray(cmds)) {
                args = opts;
                opts = cmds;
                cmds = [];
            }

            return Q.when(this._parseCmd(cmds), (p) => {
                if(p.argv.length)
                    return this.reject(`Unknown command: ${cmds.join(' ')}`);

                return Q.all([this._processParams(opts, this._opts), this._processParams(args, this._args)])
                    .spread((_opts, _args) =>
                        this._do({
                            cmd : p.cmd,
                            opts : _opts,
                            args : _args
                        })
                        .fail((res) => (res && res.exitCode === 0)?
                            res.toString()
                            : this.reject(res)));
            });
        }
    }

    /**
     * Convenient function to run command from tests.
     *
     * @param {String[]} argv - arguments
     * @returns {Q.Promise}
     */
    Cmd.prototype.do = function(argv) {
        return this._do(this._parseArr(argv || []));
    };

    function tryCatch(fn, cb) {
        try {
            return fn();
        } catch(e) {
            return cb(e);
        }
    }

    module.exports = Cmd;